var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { Auth } from 'aws-amplify';
import OnCheckSession from './OnCheckSession';
/**
 * Confirm change password flow started by {@link OnForgotPassword}
 * @param code user code used to confirm account
 * @param userName the user to confirm
 * @param newPassword the new password for user
 * @returns See {@link IAuthenticationResult}
 */
export const OnConfirmPassword = (code, userName, newPassword) => __awaiter(this, void 0, void 0, function* () {
    try {
        const codeInt = Number(code);
        if (!codeInt || codeInt < 100) {
            throw Error('Not a valid Code');
        }
        yield Auth.forgotPasswordSubmit(userName, codeInt.toString(), newPassword);
        return OnCheckSession();
    }
    catch (error) {
        // if (__DEV__) console.log(error);
        return OnCheckSession(error);
    }
});
export default OnConfirmPassword;
//# sourceMappingURL=OnConfirmPassword.js.map