var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import OnCheckSession from './OnCheckSession';
import { Auth } from 'aws-amplify';
/**
 * Start the change password flow with AWS Cognito, followed by the {@link OnConfirmPassword}
 * @param input See {@link ICognitoUserVariables}
 * @returns See {@link IAuthenticationResult}
 */
export const OnForgotPassword = (username) => __awaiter(this, void 0, void 0, function* () {
    try {
        const result = yield Auth.forgotPassword(username);
        return OnCheckSession(result);
    }
    catch (error) {
        // if (__DEV__) console.log(error);
        return OnCheckSession(error);
    }
});
export default OnForgotPassword;
//# sourceMappingURL=OnForgotPassword.js.map