import React from 'react';
import { View } from 'react-native';
import { CrossEditor, CrossButton, } from 'react-native-cross-components';
import styles from '../../styles';
import { Colors } from 'react-native-cross-components';
/**
 * Allows the user to input e-mail and press "Resend password" button.
 *
 * Expects {@link IForgotFormProps.onSubmit} callback event.
 *
 * Properties are {@link IForgotFormProps}.
 */
export class ForgotForm extends React.Component {
    render() {
        return (React.createElement(View, { style: [styles.container], testID: this.props.testID },
            this.props.children,
            React.createElement(CrossEditor, Object.assign({ label: 'E-mail', placeholder: 'E-mail', autoCapitalize: 'none', clearButtonMode: 'always', autoCorrect: false, value: this.props.initialEmail || '', onChangeText: (text) => this.props.onEmailChanged(text) }, this.props.emailInputProps)),
            React.createElement(CrossButton, Object.assign({ style: styles.marginTop10, buttonStyle: styles.buttonStyle, onPress: this.props.onSubmit, mode: 'contained', title: 'Reset password', backgroundColor: Colors.NextButton }, this.props.buttonProps))));
    }
}
export default ForgotForm;
//# sourceMappingURL=ForgotForm.js.map