import React from 'react';
import { IEmailProps, IPasswordProps, ITestIDProps } from '../../types';
/**
 * Props for the {@link LoginForm} components.
 *
 * Required props include {@link IEmailProps.onEmailChanged} and {@link IPasswordProps.onPasswordChanged}.
 *
 * Allows you to customize {@link IEmailProps.initialEmail} / password as well as {@link IEmailProps.emailInputProps}.
 */
export interface ILoginFormProps extends IEmailProps, IPasswordProps, ITestIDProps {
}
/**
 * Allows the user to ender credentials and passes them back through prop events.
 *
 * Props are {@link ILoginFormProps}
 */
export declare class LoginForm extends React.Component<ILoginFormProps> {
    render(): JSX.Element;
}
export default LoginForm;
//# sourceMappingURL=LoginForm.d.ts.map