import React from 'react';
import { IPhoneProps, IEmailProps, IPasswordProps, ITestIDProps } from '../../types';
/**
 * Props for the {@link RegisterForm} components. Extends {@link ILoginFormProps}
 *
 * Required props are callbacks {@link IEmailProps.onEmailChanged}, {@link IPhoneProps.onPhoneChanged} and {@link IPasswordProps.onPasswordChanged}.
 *
 * Allows you to customize {@link IEmailProps.initialEmail} / phone / password as well as {@link IEmailProps.emailInputProps}.
 */
export interface IRegisterFormProps extends IEmailProps, IPasswordProps, IPhoneProps, ITestIDProps {
}
/**
 * Allows the user to enter user info and passes them back through prop events.
 *
 * Props are {@link IRegisterFormProps}
 */
export declare class RegisterForm extends React.Component<IRegisterFormProps> {
    render(): JSX.Element;
}
export default RegisterForm;
//# sourceMappingURL=RegisterForm.d.ts.map