import React from 'react';
import { View } from 'react-native';
import { CrossEditor, styles } from 'react-native-cross-components';
/**
 * Allows the user to enter user info and passes them back through prop events.
 *
 * Props are {@link IRegisterFormProps}
 */
export class RegisterForm extends React.Component {
    render() {
        // TODO: Country selector
        // maskProps={{ type: 'cel-phone', options: { dddMask: '(46)' } }}
        return (React.createElement(View, { style: [styles.container], testID: this.props.testID },
            this.props.children,
            React.createElement(CrossEditor, Object.assign({ label: 'E-mail', placeholder: 'E-mail', autoCapitalize: 'none', clearButtonMode: 'always', autoCorrect: false, value: this.props.initialEmail || '', onChangeText: (text) => this.props.onEmailChanged(text) }, this.props.emailInputProps)),
            React.createElement(CrossEditor, Object.assign({ keyboardType: 'phone-pad', label: 'Phone', autoCorrect: false, placeholder: '+NN NNN NNN NNN NNN', value: this.props.initialPhone || '', onChangeText: (text) => this.props.onPhoneChanged(text) }, this.props.phoneInputProps)),
            React.createElement(CrossEditor, Object.assign({ label: 'Password', clearButtonMode: 'always', secureTextEntry: true, value: this.props.initialPassword || '', onChangeText: (text) => this.props.onPasswordChanged(text) }, this.props.passwordInputProps))));
    }
}
export default RegisterForm;
//# sourceMappingURL=RegisterForm.js.map